if not Watcher then return end
local LBF = LibStub("LibButtonFacade", true)
local L = LibStub("AceLocale-3.0"):GetLocale("Watcher")
local media = LibStub:GetLibrary("LibSharedMedia-3.0");
local C = Watcher.constants

function Watcher:addicon(spellname, spellID)
	C[spellname], _, C[spellname.." Icon"] = GetSpellInfo(spellID)
end

function Watcher:Debuff(name, casttime, stack) -- basically, dots
	local def = Watcher.defaults.char.spell
	k = C[name]
	def.spellname[k] = C[name]
	def.name[k] = k
	def.icon[k] = C[name.." Icon"]
	def.trackspell[k] = C[name]
	def.typedot[k] =  true -- true if looking for an aura (on caster or target)
	def.stockspell[k] = true
	def.dotthreshold[k] = casttime or 0
	def.countreq = stack
	def.caster[k] = true -- ignore other player's debuffs
end

function Watcher:Buff(buff, name) -- buff that can be maintained 100% up
	local def = Watcher.defaults.char.spell
	k = C[name]
	def.spellname[k] = C[name]
	def.name[k] = k
	def.icon[k] = C[buff.." Icon"]
	def.trackspell[k] = C[buff]
	def.typedot[k] =  true -- true if looking for an aura (on caster or target)
	def.isbuff[k] =  true -- true if %trackspell is an aura on the caster
	def.stockspell[k] = true
end

function Watcher:BuffPerm(name) -- buff that doesn't fade
	local def = Watcher.defaults.char.spell
	k = C[name]
	def.spellname[k] = C[name]
	def.name[k] = k
	def.icon[k] = C[name.." Icon"]
	def.trackspell[k] = C[name]
	def.typedot[k] =  true -- true if looking for an aura (on caster or target)
	def.isbuff[k] =  true -- true if %trackspell is an aura on the caster
	def.nocd[k] = true -- true if the buff will not fade
	def.stockspell[k] = true
end

function Watcher:Direct(name) -- direct damage and the sort
	local def = Watcher.defaults.char.spell
	k = C[name]
	def.spellname[k] = C[name]
	def.name[k] = k
	def.icon[k] =  C[name.." Icon"]
	def.stockspell[k] = true -- no idea
end

function Watcher:Capitalize(debuff, name) -- while %debuff is applied, cast %name
	local def = Watcher.defaults.char.spell
	k = C[name].." w/ "..debuff
	def.spellname[k] = C[name]
	def.name[k] = k
	def.icon[k] = C[name.." Icon"]
	def.typedot[k] =  true -- true if looking for an aura (on caster or target)
	def.trackspell[k] = C[debuff]
	def.stockspell[k] = true
	def.caster[k] = true -- ignore other player's debuffs
end

function Watcher:Proc(buff, name) -- when %buff is triggered on self, cast %name
	local def = Watcher.defaults.char.spell
	k = C[name].." w/ "..buff
	def.spellname[k] = C[name]
	def.name[k] = k -- sets definition names
	def.icon[k] =  C[buff.." Icon"]
	def.trackspell[k] = buff -- which spell to look for
	def.typedot[k] =  true -- true if looking for an aura (on caster or target)
	def.isproc[k] =  true -- true if %trackspell is something that should be shown only when it's there
	def.isbuff[k] =  true -- true if %trackspell is an aura on the caster
	def.stockspell[k] = true
end

function Watcher:PowerThreshold(power, reverse, name)
	local def =	Watcher.defaults.char.spell
	k = C[name]
	def.powerthresh[k] = power
	def.negthreshold[k] = reverse
end